/******************************************************************************
*
* Copyright (c) 2013 - 2016, Freescale Semiconductor, Inc.
* Copyright 2016-2017 NXP
* All rights reserved.
*
***************************************************************************//*!
*
* @file acmp.c
*
* @author nxa07754
*
* @version 0.0.1
*
* @date Oct 20, 2017
*
* @brief providing APIs for configuring analog comparator (ACMP). 
*
*******************************************************************************
*
* provide ACMP drivers
******************************************************************************/
#include "common.h"
#include "printf.h"
#include "acmp.h"
/*****************************************************************************//*!
   +FUNCTION----------------------------------------------------------------
   * @function name: ACMP_Init
   *
   * @brief initialize ACMP
   *        
   * @param  none 
   *
   * @return none
   *
   * @ Pass/ Fail criteria: none
   *****************************************************************************/
void ACMP_Init ( void )
{
    //ACMP_C1_DACVAL = 34;          //when 3.3V powered: 6bit DAC: (34/64)*3.3 = 1.75V
    ACMP_C1_DACVAL = 35;             //when 5V powered:  6bit DAC: (35/64)*5 = 2.70V
    ACMP_C1 |= ACMP_C1_DACEN_MASK | ACMP_C1_DACREF_MASK;    // enable DAC, select VDDA as the reference
    ACMP_C0_ACPSEL = 0x03;          // ACMP positive input: DAC output
    ACMP_C0_ACNSEL = 0x00;          // ACMP negative input: external PTA0/ACMP0
    ACMP_C2_ACIPE = 0x01;            // enable ACMP0 input on PTA0

    //for test purpose, output the ACO to check the ACMP result on falling/rising ACMP interrupt
    ACMP_CS_ACMOD = 0x3;             //ACMP interrupt on output falling/rising edge
    ACMP_CS_ACIE = 1;                   //enable ACMP interrupt to detect the start bit of SCI0 Rx

    ACMP_CS_ACE = 1;                    // enable ACMP
}
