/******************************************************************************
*
* Copyright (c) 2013 - 2016, Freescale Semiconductor, Inc.
* Copyright 2016-2017 NXP
* All rights reserved.
*
***************************************************************************//*!
*
* @file ftm.c
*
* @author nxa07754
*
* @version 0.0.1
*
* @date Oct 20, 2017
*
* @brief providing APIs for configuring flex timer module (FTM).
*
*******************************************************************************/
#include "common.h"
#include "Uart.h"
#include "irda.h"
#include "s08p_lite_board.h"
#include "printf.h"
#include "string.h"
#include "ftm.h"

/*****************************************************************************//*!
   +FUNCTION----------------------------------------------------------------
   * @function name: FTM0CH0_Init
   *
   * @brief initialize FTM0CH0, EPWM output mode,frequency is 38khz
   *        
   * @param  none 
   *
   * @return none
   *
   * @ Pass/ Fail criteria: none
   *****************************************************************************/
void FTM0CH0_Init( void )
{
    // Init FTM0 to PWM output, frequency is 38KHz
    FTM0_MOD = FTM0_MOD_VALUE;
    FTM0_C0SC = 0x28;
    FTM0_C0V = FTM0_C0V_VALUE;
    FTM0_SC = 0x08;                 //clock source = bus clock divide by 2
}

 // Init FTM1CH0 to FTM output to driver the Buzzer, 
void FTM1_Init( void )
{
    //FTM frequency = CLKS/PS/MOD = 31.25KHz/2/10=1.563KHz
    FTM1_MOD = 9;                   //
    FTM1_C0SC = 0x28;            //edge aligned FTM
    FTM1_C0V = 4;                   //50% duty
    FTM1_SC = 0x00;                // clock source = 0, disabled the FTM
}


void FTM1_Start( void )
{
    FTM1_SC = 0x10; // clock source = 10, Fixed Frequency Clock (ICSFFCLK) divided by 2 (default), start the ftm counter
}

void FTM1_Stop( void )
{
    FTM1_SC = 0x00; //clock source = 00, stop the ftm counter
}

