/******************************************************************************
*
* Copyright (c) 2013 - 2016, Freescale Semiconductor, Inc.
* Copyright 2016-2017 NXP
* All rights reserved.
*
***************************************************************************//*!
*
* @file mtim.h
*
* @author nxa07754
*
* @version 0.0.1
*
* @date Oct 20, 2017
*
* @brief providing APIs for configuring modulo timer (MTIM). 
*
******************************************************************************/
#ifndef MTIM_H_
#define MTIM_H_

/******************************************************************************
* Includes
******************************************************************************/

/******************************************************************************
* Constants
******************************************************************************/

/******************************************************************************
* Macros
******************************************************************************/
// define MTIM0 overflow time
#define MTIM0_CLOCK				31250u
#define MTIM0_PERIOD			100  //ms
//#define MTIM0_MOD_VALUE			((unsigned char)(MTIM0_CLOCK*MTIM0_PERIOD/1000))
#define MTIM0_MOD_VALUE   MTIM0_PERIOD


/******************************************************************************
* Types
******************************************************************************/

/******************************************************************************
* Global variables
******************************************************************************/

/******************************************************************************
* Global functions
******************************************************************************/

extern void MTIM0_Init(void);
extern void MTIM0_Start(void);
extern void MTIM0_Stop(void);
extern void MTIM1_Init( void );
extern void MTIM1_Start(void);
extern void MTIM1_Stop(void);

#endif /* MTIM_H_ */
