/******************************************************************************
*
* Copyright (c) 2013 - 2016, Freescale Semiconductor, Inc.
* Copyright 2016-2017 NXP
* All rights reserved.
*
***************************************************************************//*!
*
* @file spi.c
*
* @author nxa07754
*
* @version 0.0.1
*
* @date Oct 20, 2017
*
* @brief providing APIs for configuring serial peripheral interface (SPI). 
*
******************************************************************************/
#include "common.h"
#include "spi.h"
#include "string.h"
#include "printf.h"

void SPI0_Init (void)
{
    volatile char dummy;
    
    SCG_C3 |= SCG_C3_SPI0_MASK;    // enable bus clock gate to SPI0 module

    SPI0_CS_PIN_Init();
    // SPI0 initial
    //SYS_SOPT1_SPI0PS  = 1;        //SPI0 SPSCK0, MOSI0, MISO0, and SS0 are mapped on PTE0, PTE1, PTE2, and PTE3.
    SPI0_C1_MSTR = 1;                   //master
    SPI0_C1_CPHA = 0;			//
    SPI0_BR = 0x34;                        // Baud rate divisor is 2,Baud rate prescaler divisor is 1                              
    dummy = SPI0_D;
    SPI0_C1_SPE  = 1;                    // enable SPI module
}

void SPI1_Init (void)
{
    volatile char dummy;

    SCG_C3 |= SCG_C3_SPI1_MASK;    // enable bus clock gate to SPI1 module

    // SPI1 initial
    SPI1_CS_PIN_Init();
    
    SPI1_C1_MSTR = 1;                     // SPI master
    SPI1_C1_CPHA = 0;			    //
    SPI1_C2_SPIMODE = 0;              // 8 bit, SPI hardware match interrupt disable,polling
    SPI1_BR = 0x78;                         // Baud rate divisor is 512, Baud rate prescaler divisor is 8
    SPI1_C3_FIFOMODE = 0;            // FIFO disabled
    SPI1_S |= SPI1_S_SPTEF_MASK;
    dummy = SPI1_DL;
    dummy = SPI1_DH;
    SPI1_C1_SPE = 1;             // enable
}

void SPI1_WriteReadByte (uint8_t u8WrData, uint8_t *u8RdData)
{
    uint8_t u8RdTemp;
    
    while(!SPI1_S_SPTEF);             // wait until SPI Tx buffer empty
    SPI1_DL = u8WrData;

    while(!SPI1_S_SPRF);               // wait until there's data in SPI Rx buffer
    //while ((SPI1_S & SPI1_S_SPRF_MASK) != SPI1_S_SPRF_MASK);
    if (u8RdData != NULL)
    {
        *u8RdData = SPI1_DL;
    }
    else
    {
        u8RdTemp = SPI1_DL;
    }
}
