/******************************************************************************
*
* Copyright (c) 2013 - 2016, Freescale Semiconductor, Inc.
* Copyright 2016-2017 NXP
* All rights reserved.
*
***************************************************************************//*!
*
* @file spi.h
*
* @author nxa07754
*
* @version 0.0.1
*
* @date Oct 20, 2017
*
* @brief providing APIs for configuring serial peripheral interface (SPI). 
*
******************************************************************************/

#ifndef SPI_H_
#define SPI_H_

#include "mc9s08pt60.h"
#include "common.h"

/******************************************************************************
* Macros
******************************************************************************/
#define SPI0_CS_PIN_Init()	PORT_PTEOE_PTEOE3 = 1
#define SPI0_CS_HIGH()		PORT_PTED_PTED3 = 1
#define SPI0_CS_LOW()		PORT_PTED_PTED3 = 0

#define SPI1_CS_PIN_Init()	     PORT_PTDOE_PTDOE3 = 1
#define SPI1_CS_HIGH()	            PORT_PTDD_PTDD3 = 1
#define SPI1_CS_LOW()		     PORT_PTDD_PTDD3 = 0
/******************************************************************************
* Global functions
******************************************************************************/
extern void SPI0_Init(void);
extern void SPI1_Init(void);
extern unsigned char Test_SPI(void);
extern void SPI1_WriteReadByte (uint8_t u8WrData, uint8_t *u8RdData);

#endif /* SPI_H_ */

