/******************************************************************************
*
* Copyright (c) 2013 - 2016, Freescale Semiconductor, Inc.
* Copyright 2016-2017 NXP
* All rights reserved.
*
***************************************************************************//*!
*
* @file s08p_lite_board.h
*
* @author nxa07754
*
* @version 0.0.1
*
* @date Oct 20, 2017
*
*******************************************************************************/

#ifndef s08p_lite_board_H_
#define s08p_lite_board_H_

#include "mc9s08pt60.h"
#include "commonTypes.h"

/* define print system log */
#define PRINT_SYS_LOG

/* define output bus clock */
//#define OUTPUT_BUSCLK

/* define what clock mode at startup 
 * if USE_FEE is not defined by commenting out the following line, 
 * then it will use FEI mode which is default mode 
 * after reset  
 */
#define USE_FEE		/* FEE clock mode */	

/* define external crystal frequency */
#define EXT_CLK_CRYST	8000	//PT60-LITE board includes 8MHz	external osc

/* define BUS clock in HZ */
#define  BUS_CLK_HZ		16000000L

/* define UART baud rate */
#define BR_9600

/* define SCI port # to be used */
#define USE_SCI		3

#define DAC5571_I2C_ADDRESS    0x4C   // SA0 = 0


#define LED0_Init()                 PORT_PTEOE_PTEOE7 = 1
#define LED0_Toggle()		    PORT_PTED_PTED7  ^= 1
#define LED0_On()		    PORT_PTED_PTED7   = 0
#define LED0_Off()		    PORT_PTED_PTED7   = 1

#define LED1_Init()                 PORT_PTGOE_PTGOE0 = 1
#define LED1_Toggle()	           PORT_PTGD_PTGD0  ^= 1
#define LED1_On()		    PORT_PTGD_PTGD0   = 0
#define LED1_Off()		    PORT_PTGD_PTGD0   = 1

#define LED2_Init()                 PORT_PTGOE_PTGOE1 = 1
#define LED2_Toggle()            PORT_PTGD_PTGD1  ^= 1
#define LED2_On()                   PORT_PTGD_PTGD1   = 0
#define LED2_Off()                  PORT_PTGD_PTGD1   = 1

#define LED3_Init()                 PORT_PTGOE_PTGOE2 = 1
#define LED3_Toggle()            PORT_PTGD_PTGD2  ^= 1
#define LED3_On()                  PORT_PTGD_PTGD2   = 0
#define LED3_Off()                  PORT_PTGD_PTGD2   = 1

#define LED4_Init()                 PORT_PTGOE_PTGOE3 = 1
#define LED4_Toggle()            PORT_PTGD_PTGD3  ^= 1
#define LED4_On()                  PORT_PTGD_PTGD3   = 0
#define LED4_Off()                  PORT_PTGD_PTGD3   = 1

#define LED5_Init()                 PORT_PTHOE_PTHOE2 = 1
#define LED5_Toggle()            PORT_PTHD_PTHD2  ^= 1
#define LED5_On()		    PORT_PTHD_PTHD2   = 0
#define LED5_Off()		    PORT_PTHD_PTHD2   = 1

#define LED6_Init()                 PORT_PTHOE_PTHOE6 = 1
#define LED6_Toggle()            PORT_PTHD_PTHD6  ^= 1
#define LED6_On()		    PORT_PTHD_PTHD6   = 0
#define LED6_Off()		    PORT_PTHD_PTHD6   = 1

#define LED7_Init()                 PORT_PTHOE_PTHOE7 = 1
#define LED7_Toggle()	           PORT_PTHD_PTHD7  ^= 1
#define LED7_On()		    PORT_PTHD_PTHD7   = 0
#define LED7_Off()		    PORT_PTHD_PTHD7   = 1

#define PTD0_Init()                 PORT_PTDOE_PTDOE0 = 1
#define PTD0_Toggle()	           PORT_PTDD_PTDD0  ^= 1
#define PTD0_Set()		    PORT_PTDD_PTDD0   = 1
#define PTD0_Clear()               PORT_PTDD_PTDD0   = 0


#define LED_ELECTROD_PTG0_Init()	    PORT_PTGOE_PTGOE0 = 1
#define LED_ELECTROD_PTG0_Toggle()		PORT_PTGD_PTGD0  ^= 1
#define LED_ELECTROD_PTG0_On()		    PORT_PTGD_PTGD0   = 0
#define LED_ELECTROD_PTG0_Off()		    PORT_PTGD_PTGD0   = 1

void DelayMS(uint16_t timeMS);

extern void Sys_Init(void);
extern void Button_Init(void);
extern void configure_LEDs_for_GPIO(void);
extern void configure_LEDs_for_PWM (void);
extern void leds_all_on (void);
extern void leds_all_off (void);
extern void leds_cross(void);
extern void leds_plus(void);
 extern void LED_Init(void);                 //init LED
extern void LED_Test(void);
extern void Buzzer_Init(void);              //init Buzzer
extern void Buzzer_On(void);
extern void Buzzer_Off(void);
extern void Buzzer_Test(void);
extern void Buzzer_Beep(void);
extern void Button_Init(void);            //  init  KBI
extern void Button_Test(void);
extern void DbgConsole_Init(void);                 // init Serial Communications Interface (SCI)
extern void DAC5571_Init(void);        // init DAC5571
extern void DAC5571WriteData(unsigned char u8Data);
extern void DAC5571_Test(void);
extern void Irda_Init(void);                   // init Irda transceiver
extern void FlashW25Q32_Init(void);         // init the external flash IC
extern void FlashW25Q32_Test(void);
extern void Touchpad_Init(void);            //init touch pad
extern void AnalogInput_Init(void);            //init potentiometer, thermistor
extern void AnalogCompare_Init(void);         // init CMP
    
#endif /* s08p_lite_board_H_ */
